import Vue from 'vue';
import { SnotifyToast } from '../SnotifyToast/toast.model';
import { SnotifyNotifications } from '../../interfaces';
export declare class Snotify extends Vue {
    /**
     * Toasts array
     */
    notifications: SnotifyNotifications;
    /**
     * Helper for slice pipe (maxOnScreen)
     */
    dockSize_a: number;
    /**
     * Helper for slice pipe (maxOnScreen)
     */
    dockSize_b: number | undefined;
    /**
     * Helper for slice pipe (maxAtPosition)
     */
    blockSize_a: number;
    /**
     * Helper for slice pipe (maxAtPosition)
     */
    blockSize_b: number | undefined;
    /**
     * Backdrop Opacity
     */
    backdrop: number;
    /**
     * How many toasts with backdrop in current queue
     */
    withBackdrop: SnotifyToast[];
    setOptions(toasts: any): void;
    /**
     * Changes the backdrop opacity
     * @param {SnotifyEvent} event
     */
    stateChanged(event: any): void;
    /**
     * Split toasts toasts into different objects
     * @param {SnotifyToast[]} toasts
     * @returns {SnotifyNotifications}
     */
    splitToasts(toasts: any): {};
    created(): void;
}
