import Vue from 'vue';
import { SnotifyToast } from './toast.model';
export declare class Toast extends Vue {
    toastData: SnotifyToast;
    toast: SnotifyToast;
    animationFrame: any;
    state: {
        paused: boolean;
        progress: number;
        animation: string;
        isDestroying: boolean;
        promptType: "simple" | "success" | "error" | "warning" | "info" | "async" | "confirm" | "prompt";
    };
    /**
     * Initialize base toast config
     */
    initToast(): void;
    onClick(): void;
    onMouseEnter(): void;
    onMouseLeave(): void;
    /**
     * Remove toast completely after animation
     */
    onExitTransitionEnd(): void;
    /**
     * Start progress bar
     * @param startTime {number}
     * @default 0
     */
    startTimeout(startTime?: number): void;
    /**
     * Trigger beforeDestroy lifecycle. Removes toast
     */
    onRemove(): void;
    created(): void;
    mounted(): void;
    destroyed(): void;
}
